<?php
if (!defined('OLDPAL_COMMON_PHP')) {
define('OLDPAL_COMMON_PHP', null);



//
// +----------------------------------------------------------------------+
// | PHP version 4.0                                                      |
// +----------------------------------------------------------------------+
// +----------------------------------------------------------------------+
// | Authors: Jacky Ko
// +----------------------------------------------------------------------+
//
// $Id: oldpal_common.php,v 1.1 2003/10/19 08:01:11 root Exp root $
//
// Oldpal_Common
//

include_once('DB.php');

class DB_oldpal_common
{
	var $oldpal_owner = '';
	var $oldpal_service = '';
	var $debugLevel = 0;

	function action($oldpal_resource, $oldpal_action = 'select', $oldpal_getSQL = false)
	{
if ($this->debugLevel) printf("<b>function</b> %s::action([%s], [%s])<br>\n", get_class($this), $oldpal_resource, $oldpal_action);

		$oldpal_action_arr = explode(':', $oldpal_action);
		if ($oldpal_action_arr[0] == 'sql')
		{
			// Safe guard check
			if ($oldpal_action_arr[1] != '' && !ereg('^' . $oldpal_action_arr[1] . ' ', $oldpal_resource))
			{
				return $this->raiseError();
			}
			return $this->simpleQuery($this->setSQL($oldpal_resource));
		}

		$oldpal_owner = $this->getOwner();
		$oldpal_service = $this->getService();
		$debugLevel = $this->getDebugLevel();
		$oldpal_result = NULL;

		$FORM_VARS = &takeFormVars();

		$include_file = 'bee.res/' .
			$this->oldpal_owner . '/' .
			$this->oldpal_service . '/' .
			$oldpal_resource . '_act.php';

if ($this->debugLevel) printf("\$include_file = [%s]<br>\n", $include_file);

		include($include_file);

		if (!DB::isError($oldpal_result))
		{
if ($this->debugLevel) printf("oldpal_result OK (not DB::isError)<br>\n");

			if ($oldpal_getSQL)
			{
				// $SQLCommand was from the include file.
				return $SQLCommand;
			} else
			{
if ($this->debugLevel) printf("\$oldpal_action = [%s]<br>\n", $oldpal_action);
				switch ($oldpal_action)
				{
				case 'count':
					return $this->numRows($oldpal_result);
				}
			}
		}

		return $oldpal_result;
	}


	function display($oldpal_resource, $oldpal_result = -1)
	{
if ($this->debugLevel) printf("<b>function</b> %s::display([$oldpal_resource], [$oldpal_result])<br>\n", get_class($this));
		$oldpal_owner = $this->getOwner();
		$oldpal_service = $this->getService();
		$debugLevel = $this->getDebugLevel();

		if (DB::isError($oldpal_result))
		{
			return $oldpal_result;
		}

		$FORM_VARS = &takeFormVars();

		$include_file = 'bee.res/' .
			$this->oldpal_owner . '/' .
			$this->oldpal_service . '/' .
			$oldpal_resource . '_dis.php';
if ($this->debugLevel) printf("\$include_file = [%s]<br>\n", $include_file);

		include($include_file);

		return $oldpal_result;
	}


	function getSelectList($dbobj, $qry, $fmt = '%s:%s', $optsep = '|')
	{
		$ret = '';
		$res = $dbobj->simpleQuery($qry);
		if (DB::isError($res)) return $ret;

		//$row = $dbobj->fetchRow($res);
		$dbRes = new DB_result($dbobj, $res);
		$row = $dbRes->fetchRow();
		while (!DB::isError($row) && count($row) > 0)
		{
			if (empty($row[1])) $row[1] = $row[0];
			if (empty($row[2])) $row[2] = $row[0];
			$ret .= sprintf($fmt, $row[0], $row[1], $row[2]) . $optsep;
			//$row = $dbobj->fetchRow($res);
			$row = $dbRes->fetchRow();
		}
		$dbobj->freeResult($res);
		$ret = ereg_replace('\\' . $optsep . '$', '', $ret);

		return $ret;
	}



	function quoteString($string)
	{
		// single quote does not need quoting as it's done automatically in FORM_VARS by PHP
		$enc = $string;
		$enc = str_replace('$', '\\$', $enc);
		$enc = str_replace('^', '\\^', $enc);
		$enc = str_replace("\r\n", '\\n', $enc);
		$enc = str_replace("\n", '\\n', $enc);
		return $enc;
	}


	function unquoteString($string)
	{
		// single quote does need unquoting as it would be done automatically in FORM_VARS by PHP
		$dec = $string;
		$dec = str_replace("\\'", "'", $dec);
		$dec = str_replace('\\n', "\n", $dec);
		return $dec;
	}


	function getSQL($sqlAction)
	{
		return $this->SQLCommand[$sqlAction];
	}


	function setSQL($sql)
	{
		$sqlAction = ereg_replace(' .*', '', $sql);
		$this->SQLCommand[$sqlAction] = $sql;
		return $sql;
	}
}



}  // OLDPAL_COMMON_PHP
?>
