<?php
if (!defined('OLDPAL_MSQL_PHP')) {
define('OLDPAL_MSQL_PHP', null);



//
// +----------------------------------------------------------------------+
// | PHP version 4.0                                                      |
// +----------------------------------------------------------------------+
// +----------------------------------------------------------------------+
// | Authors: Jacky Ko
// +----------------------------------------------------------------------+
//
// $Id: oldpal_msql.php,v 1.1 2003/10/19 08:01:11 root Exp root $
//
// Database independent query interface definition for Oldpal PHP
// extension.
//

include_once('DB.php');
include_once('DB/oldpal_common.php');
include_once('DB/msql.php');

class DB_oldpal_msql extends DB_msql
{
	var $oldpal_owner = '';
	var $oldpal_service = '';
	var $oldpal_dbid = '';  // Dummy
	var $oldpal_dbtype = '';
	var $oldpal_host = '';
	var $oldpal_database = '';
	var $SQLCommand = array();

	var $debugLevel = 0;

	function DB_oldpal_msql()
	{
		$this->DB_msql();
	}


	// For non-CROFT version, look for CROFT info from the arglist.
	function connect($dsn = '', $persistent = false, $owner = '', $service = '')
	{
if ($this->debugLevel) printf("<b>function</b> %s::connect<br>\n", get_class($this));
		global $BeeCroft;
		if (isset($BeeCroft))
		{
			list ($this->oldpal_owner, $this->oldpal_service)
				= $BeeCroft->getOwnerService();
			list ($this->oldpal_dbid, $this->oldpal_dbtype, $this->oldpal_host, $this->oldpal_database, $AuthUsername, $AuthPassword)
				= $BeeCroft->getAllDataInfo();
		} else
		{
			$this->oldpal_owner = $owner;
			$this->oldpal_service = $service;

			if(is_array($dsn))
			{
				$dsninfo = &$dsn;
			} else
			{
				$dsninfo = DB::parseDSN($dsn);
			}
			if (!$dsninfo || !$dsninfo['phptype'])
			{
				return $this->raiseError(); 
			}
			$this->oldpal_dbtype = $dsninfo['phptype'];
			$this->oldpal_host = $dsninfo['hostspec'] ? $dsninfo['hostspec'] : 'localhost';
			$this->oldpal_database = $dsninfo['database'];
			$AuthUsername = $dsninfo['username'];
			$AuthPassword = $dsninfo['password'];
		}

if ($this->debugLevel)
{
	printf("\$oldpal_owner = [%s]<br>\n", $this->oldpal_owner);
	printf("\$oldpal_service = [%s]<br>\n", $this->oldpal_service);
	printf("\$oldpal_dbid = [%s]<br>\n", $this->oldpal_dbid);
	printf("\$oldpal_dbtype = [%s]<br>\n", $this->oldpal_dbtype);
	printf("\$oldpal_host = [%s]<br>\n", $this->oldpal_host);
	printf("\$oldpal_database = [%s]<br>\n", $this->oldpal_database);
	printf("\$AuthUsername = [%s] (ignored anyway)<br>\n", $AuthUsername);
	printf("\$AuthPassword = [***] (ignored anyway)<br>\n", $AuthPassword);
}

		$connect_function = $persistent ? 'msql_pconnect' : 'msql_connect';
		// if ($this->oldpal_host && $AuthUsername && $AuthPassword)
		// {
		//	$conn = $connect_function($this->oldpal_host, $AuthUsername, $AuthPassword);
		//} elseif ($this->oldpal_host && $AuthUsername)
		//{
		//	$conn = $connect_function($this->oldpal_host, $AuthUsername);
		//} else
		if ($this->oldpal_host)
		{
			$conn = @$connect_function($this->oldpal_host);
		}

		if ($conn === false)
		{
if ($this->debugLevel) printf("%s::connect returns ERROR<br>\n", get_class($this));
			return $this->raiseError();
		} else
		{
			if ($this->oldpal_database)
			{
				@msql_select_db($this->oldpal_database, $conn);
			} else
			{
if ($this->debugLevel) printf("%s::connect select_db returns ERROR<br>\n", get_class($this));
				return $this->raiseError();
			}
			$this->connection = $conn;
if ($this->debugLevel) printf("%s::connect returns DB_OK<br>\n", get_class($this));
			return DB_OK;
		}
	}

	function disconnect()
	{
if ($this->debugLevel) printf("<b>function</b> %s::disconnect<br>\n", get_class($this));
		return @msql_close($this->connection);
	}

	function setDebugLevel($level)
	{
//if ($this->debugLevel || $level) printf("<b>function</b> %s::setDebugLevel([$level])<br>\n", get_class($this));
		$this->debugLevel = $level;
		return DB_OK;
	}

	function numRows($result)
	{
		$rows = @msql_num_rows($result);
		if ($rows < 0)
		{
if ($this->debugLevel) printf("%s::numRows returns ERROR<br>\n", get_class($this));
			return $this->raiseError();
		}
if ($this->debugLevel) printf("%s::numRows returns $rows<br>\n", get_class($this));
		return $rows;
	}

	function seekRow($result, $rownum = 0)
	{
		if (!@msql_data_seek($result, $rownum))
		{
if ($this->debugLevel) printf("%s::seekRow returns ERROR<br>\n", get_class($this));
			return $this->raiseError();
		}
if ($this->debugLevel) printf("%s::seekRow returns DB_OK<br>\n", get_class($this));
		return DB_OK;
	}

	function nextSeq($table)
	{
		$result = msql_query("select _seq from $table", $this->connection);
		if (!$result) return $this->raiseError();
		$row = msql_fetch_row($result);
		if (!$row) return $this->raiseError();
		return (int)$row[0];
	}

	function lastSeq()
	{
		return -1;
	}

	function commonRegExp($Str)
	{
		$ret = $Str;
		$ret = ereg_replace("\?", "_", $ret);
		$ret = ereg_replace("\*", $this->wildRegExp(), $ret);
		return $ret;
	}

	function commonRegExpWild($Str)
	{
		return $this->commonRegExp('*' . $Str . '*');
	}

	function operatorRegExp()
	{
		return "clike";
	}

	function wildRegExp()
	{
		return "%";
	}


	function tableList()
	{
		$ret = array();
		$result = @msql_list_tables($this->oldpal_database, $this->connection);
		$rows = @msql_num_rows($result);
		for ($i = 0; $i < $rows; $i++) $ret[] = @msql_tablename($result, $i);
		return $ret;
	}


	function fieldList($tablename, $withAttr = false)
	{
		$ret = array();

		if (!is_string($tablename)) $result = $tablename;
		else $result = @msql_list_fields($this->oldpal_database, $tablename, $this->connection);

		$fields = @msql_num_fields($result);
		for ($i = 0; $i < $fields; $i++)
		{
			$attr = array
			(
				'name' => @msql_fieldname($result, $i),
				'type' => @msql_fieldtype($result, $i),
				'len' => @msql_fieldlen($result, $i),
				'flags' => @msql_fieldflags($result, $i),
			);

			if ($attr['type'] != 'unknown' && $attr['len'] != 0)
			{
				if ($withAttr) $ret[] = $attr;
				else $ret[] = $attr['name'];
			}
		}
		return $ret;
	}




// Common functions for Oldpal Object

	function getDebugLevel()
	{
		return $this->debugLevel;
	}

	function getOwner()
	{
		return $this->oldpal_owner;
	}

	function getService()
	{
		return $this->oldpal_service;
	}

	function action($oldpal_resource, $oldpal_action = 'select', $oldpal_getSQL = false)
	{
if ($this->debugLevel) printf("%s::action([%s], [%s], [%s])<br>\n", get_class($this), $oldpal_resource, $oldpal_action, $oldpal_getSQL);
		return DB_oldpal_common::action($oldpal_resource, $oldpal_action, $oldpal_getSQL);
	}

	function display($oldpal_resource, $oldpal_result = -1)
	{
if ($this->debugLevel) printf("%s::display([$oldpal_resource], [$oldpal_result])<br>\n", get_class($this));
		return DB_oldpal_common::display($oldpal_resource, $oldpal_result);
	}

	function getSelectList($qry, $fmt = '%s:%s', $optsep = '|')
	{
		return DB_oldpal_common::getSelectList($this, $qry, $fmt, $optsep);
	}

	function getSQL($sqlAction)
	{
		return DB_oldpal_common::getSQL($sqlAction);
	}

	function setSQL($sql)
	{
		return DB_oldpal_common::setSQL($sql);
	}

	function quoteString($string)
	{
		return DB_oldpal_common::quoteString($string);
	}

	function unquoteString($string)
	{
		return DB_oldpal_common::unquoteString($string);
	}
}



}  // OLDPAL_MSQL_PHP
?>
