<?php
if (!defined('OLDPAL_ODBC_PHP')) {
define('OLDPAL_ODBC_PHP', null);



//
// +----------------------------------------------------------------------+
// | PHP version 4.0                                                      |
// +----------------------------------------------------------------------+
// +----------------------------------------------------------------------+
// | Authors: Jacky Ko
// +----------------------------------------------------------------------+
//
// $Id: oldpal_odbc.php,v 1.1 2003/10/19 08:01:11 root Exp root $
//
// Database independent query interface definition for Oldpal PHP
// extension.
//

include_once('DB.php');
include_once('DB/oldpal_common.php');
include_once('DB/odbc.php');

class DB_oldpal_odbc extends DB_odbc
{
	var $oldpal_owner = '';
	var $oldpal_service = '';
	var $oldpal_dbid = '';  // Dummy
	var $oldpal_dbtype = '';
	var $oldpal_host = '';
	var $oldpal_database = '';
	var $SQLCommand = '';

	var $debugLevel = 0;

	function DB_oldpal_odbc()
	{
		$this->DB_odbc();
	}


	// For non-CROFT version, look for CROFT info from the arglist.
	function connect($dsn = '', $persistent = false, $owner = '', $service = '')
	{
if ($this->debugLevel) printf("<b>function</b> %s::connect<br>\n", get_class($this));
		global $BeeCroft;
		if (isset($BeeCroft))
		{
			list ($this->oldpal_owner, $this->oldpal_service)
				= $BeeCroft->getOwnerService();
			list ($this->oldpal_dbid, $this->oldpal_dbtype, $this->oldpal_host, $this->oldpal_database, $AuthUsername, $AuthPassword)
				= $BeeCroft->getAllDataInfo();
		} else
		{
			$this->oldpal_owner = $owner;
			$this->oldpal_service = $service;

			if(is_array($dsn))
			{
				$dsninfo = &$dsn;
			} else
			{
				$dsninfo = DB::parseDSN($dsn);
			}
			if (!$dsninfo || !$dsninfo['phptype'])
			{
				return $this->raiseError(); 
			}
			$this->oldpal_dbtype = $dsninfo['phptype'];
			$this->oldpal_host = $dsninfo['hostspec'] ? $dsninfo['hostspec'] : 'localhost';
			$this->oldpal_database = $dsninfo['database'];
			$AuthUsername = $dsninfo['username'];
			$AuthPassword = $dsninfo['password'];
		}

if ($this->debugLevel)
{
	printf("\$oldpal_owner = [%s]<br>\n", $this->oldpal_owner);
	printf("\$oldpal_service = [%s]<br>\n", $this->oldpal_service);
	printf("\$oldpal_dbid = [%s]<br>\n", $this->oldpal_dbid);
	printf("\$oldpal_dbtype = [%s]<br>\n", $this->oldpal_dbtype);
	printf("\$oldpal_host = [%s]<br>\n", $this->oldpal_host);
	printf("\$oldpal_database = [%s]<br>\n", $this->oldpal_database);
	printf("\$AuthUsername = [%s]<br>\n", $AuthUsername);
	printf("\$AuthPassword = [***]<br>\n", $AuthPassword);
}

		$connect_function = $persistent ? 'odbc_pconnect' : 'odbc_connect';
		if ($this->oldpal_host && $AuthUsername && $AuthPassword)
		{
if ($this->debugLevel) printf("%s::connect host($this->oldpal_host) user($AuthUsername) password(***)<br>\n", get_class($this));
			$conn = @$connect_function($this->oldpal_host, $AuthUsername, $AuthPassword);
		} elseif ($this->oldpal_host && $AuthUsername)
		{
if ($this->debugLevel) printf("%s::connect host($this->oldpal_host) user($AuthUsername)<br>\n", get_class($this));
			$conn = @$connect_function($this->oldpal_host, $AuthUsername);
		} else
		{
if ($this->debugLevel) printf("%s::connect host($this->oldpal_host)<br>\n", get_class($this));
			$conn = @$connect_function($this->oldpal_host);
		}

		if ($conn === false)
		{
if ($this->debugLevel) printf("%s::connect returns ERROR<br>\n", get_class($this));
			return $this->raiseError();
		}
		$this->connection = $conn;
		return DB_OK;
	}

	function disconnect()
	{
if ($this->debugLevel) printf("<b>function</b> %s::disconnect<br>\n", get_class($this));
		return @odbc_close($this->connection);
	}

	function setDebugLevel($level)
	{
//if ($this->debugLevel || $level) printf("<b>function</b> %s::setDebugLevel([$level])<br>\n", get_class($this));
		$this->debugLevel = $level;
		return DB_OK;
	}

	function numRows($result)
	{
		$rows = @odbc_num_rows($result);
		if ($rows < 0)
		{
if ($this->debugLevel) printf("%s::numRows returns ERROR<br>\n", get_class($this));
			return $this->raiseError();
		}
if ($this->debugLevel) printf("%s::numRows returns $rows<br>\n", get_class($this));
		return $rows;
	}

	function seekRow($result, $rownum = 0)
	{
		//if (!@odbc_data_seek($result, $rownum))
		//{
if ($this->debugLevel) printf("%s::seekRow returns ERROR<br>\n", get_class($this));
			return $this->raiseError();
		//}
if ($this->debugLevel) printf("%s::seekRow returns DB_OK<br>\n", get_class($this));
		//return DB_OK;
	}

	function nextSeq($table)
	{
		return -1;
	}

	function lastSeq()
	{
		return -1;
	}

	function commonRegExp($Str)
	{
		$ret = $Str;
		$ret = ereg_replace("\?", "_", $ret);
		$ret = ereg_replace("\*", $this->wildRegExp(), $ret);
		return $ret;
	}

	function commonRegExpWild($Str)
	{
		return $this->commonRegExp('*' . $Str . '*');
	}

	function operatorRegExp()
	{
		return "like";
	}

	function wildRegExp()
	{
		return "%";
	}


	function tableList()
	{
		$ret = array();
		$result = @odbc_tables($this->connection);
		while (@odbc_fetch_row($result)) { 
			if (odbc_result($result, 4) == "TABLE") $ret[] = odbc_result($result, 3);
		} 
		return $ret;
	}


	function fieldList($tablename, $withAttr = false)
	{
		$ret = array();

		if (!is_string($tablename))
		{
			$result = $tablename;
			$fields = @odbc_num_fields($result);
			for ($i = 1; $i <= $fields; $i++)
			{
				if (!$withAttr)
				{
					$ret[] = @odbc_field_name($result, $i);
				} else
				{
					$attr = array
					(
						'name' => @mysql_field_name($result, $i),
						'type' => @mysql_field_type($result, $i),
						'len' => @mysql_field_len($result, $i)
						//'flags' => @mysql_field_flags($result, $i),
					);
					$ret[] = $attr;
				}
			}
		} else
		{
			$ret = array();
			$result = @odbc_columns($this->connection);
			while (@odbc_fetch_row($result)) { 
				if (@odbc_result($result, 3) != $tablename) continue;
				if (!$withAttr)
				{
					$ret[] = @odbc_result($result, 4);
				} else
				{
					$attr = array
					(
						'name' => @odbc_result($result, 4),
						'type' => @odbc_result($result, 6),
						'len' => @odbc_result($result, 8)
						//'flags' => ''
					);
					$ret[] = $attr;
				}
			}
		}
		return $ret;
	}


// Common functions for Oldpal Object

	function getDebugLevel()
	{
		return $this->debugLevel;
	}

	function getOwner()
	{
		return $this->oldpal_owner;
	}

	function getService()
	{
		return $this->oldpal_service;
	}

	function action($oldpal_resource, $oldpal_action = 'select', $oldpal_getSQL = false)
	{
if ($this->debugLevel) printf("%s::action([$oldpal_resource], [$oldpal_action], [$oldpal_getSQL])<br>\n", get_class($this));
		return DB_oldpal_common::action($oldpal_resource, $oldpal_action, $oldpal_getSQL);
	}

	function display($oldpal_resource, $oldpal_result = -1)
	{
		return DB_oldpal_common::display($oldpal_resource, $oldpal_result);
	}

	function getSelectList($qry, $fmt = '%s:%s', $optsep = '|')
	{
		return DB_oldpal_common::getSelectList($this, $qry, $fmt, $optsep);
	}

	function getSQL($sqlAction)
	{
		return DB_oldpal_common::getSQL($sqlAction);
	}

	function setSQL($sql)
	{
		return DB_oldpal_common::setSQL($sql);
	}

	function quoteString($string)
	{
		return DB_oldpal_common::quoteString($string);
	}

	function unquoteString($string)
	{
		return DB_oldpal_common::unquoteString($string);
	}


	/* OBSOLETE
	// To compensate the difficiency of DB_odbc::fetchRow
	function &fetchRow($result, $fetchmode = DB_FETCHMODE_DEFAULT) {
		$row = DB_odbc::fetchRow($result);

		if ($fetchmode == DB_FETCHMODE_DEFAULT) {
			$fetchmode = $this->fetchmode;
		}

		if ($fetchmode & DB_FETCHMODE_ASSOC) {
			$fields = @odbc_num_fields($result);
			$rawRow = $row;
			$row = array();
			for ($i = 1; $i <= $fields; $i++)
			{
				$ndx = @odbc_field_name($result, $i);
				$row[$ndx] = $rawRow[$i - 1];
			}
		}

		if (!$row) {
			$errno = mysql_errno($this->connection);
			if (!$errno) {
				return NULL;
			}
			return $this->raiseError($this->errorCode($errno));
		}

		return $row;
	}
	 */
}




}  // OLDPAL_ODBC_PHP
?>
