<?php include("bee/compiler.php"); return; ?>
<script language="bee">

/************************************************************
 *	firewallRules: Return an action by matching a rule set
 *
 *	ruleset = an array containing elements in the format of "action type common_pattern"
 *		Note: common_pattern use * to mean anything (instead of .* as in regexp)
 *	varname = the name of the variable to match; supposingly globally accessible; default is sys%client
 *	varvalue = the array containing values of "type" to match (if present, varname will be ignored)
 *	verbose = display rule matching message
 *	Returns the "action" of the first match
 ************************************************************/

function firewallRuleset
{
	result%function = "";
	verbose = "{arg%verbose}";
	ruleset = (var)arg%ruleset;
	if ({#ruleset} == 0) ruleset = (var)arg%arg;
	if ({#ruleset} == 0) return;

	vv = (var)arg%varvalue;
	vname = "vv";
	if ({#vv} == 0) {
		vname = "{arg%varname}";
		if ({#vname:} == 0) vname = "sys%client";
		if ('{verbose}') display "No varvalue is specified, use variable [{vname}]<br>\n";
	}

	foreach (ruleset) {
		if ('{verbose}') display "Checking rule: {foreach}<br>\n";
		arr = "{foreach}" conv="split: ";
		ruleAction = (var)arr conv=shift;
		ruleType = (var)arr conv=shift;
		ruleMatchRaw = "{arr|list:(@value) ()}";
		negate = 0;
		if ('{arr:#0|lowercase}' == 'not') {
			negate = 1;
			var arr conv=shift;
		}
		rmConv = "regexp";  // Assume not regexp (so need to convert)
		if ('{arr:#0|lowercase}' == 'regexp') {
			rmConv = "";  // The pattern is already in regexp
			var arr conv=shift;
		}
		ruleMatch = "{arr|list:(@value) ()}" conv="{rmConv}";
		doesMatch = 0;
		// If ruleType is any, match
		// else If ruleType value is not blank
		//		If ruleMatch is any, match
		//		else compair to match
//display "{vname}:{ruleType}=[{{vname}:{ruleType}}]<br>\n";
		if ('{ruleType|tolower}' == 'any') {
			doesMatch = 1;
		} else if ({#{vname}:{ruleType}}) {
//display "ruleMatchRaw=[{ruleMatchRaw}]<br>\n";
			if ('{ruleMatchRaw|tolower}' == 'any') {
				doesMatch = 1;
			} else {
				doesMatch = "{{vname}:{ruleType}|foundre:{ruleMatch}}";
			}
		}
//display "ruleset=[{foreach}] action=[{ruleAction}] type=[{ruleType}] match=[{ruleMatch}] doesMatch=[{doesMatch}]<br>\n";
		if ('{negate}') {
			if ('{doesMatch}') doesMatch = 0;
			else doesMatch = 1;
		}
		if ('{doesMatch}') {
			result%function = "{ruleAction}";
			if ('{verbose}') {
				display '{vname}:{ruleType} matches "{ruleMatchRaw}"<br>\n';
				display 'Return [{result%function}]<br>\n';
			}
			break;
		}
	}
}


/************************************************************
 *	firewallScheme: Return an action by matching a rule set in a scheme file
 *
 *	scheme = The scheme file that contains the ruleset in the format of:
 *		ruleset1=action type [not] [regexp] common_pattern
 *		ruleset1=action type [not] [regexp] common_pattern
 *		...
 *		ruleset2=action type [not] [regexp] common_pattern
 *		...
 *		Note: if regexp is specified, common_pattern is in regular expression;
 *			Otherwise, common_pattern use * to mean anything (instead of .* as in regexp)
 *	ruleset = The name of the ruleset in the scheme file
 *	default = The default ruleset if the ruleset cannot be found 
 *	varname = the name of the variable to match; supposingly globally accessible; default is sys%client
 *	varvalue = the array containing values of "type" to match (if present, varname will be ignored)
 *	verbose = display rule matching message
 *	Returns the "action" of the first match
 *
 * Example of using "varvalue":
 *
 *	Ruleset:
 *		antispam=reject from *@spammer.com
 *		antispam=discard subject *viagra*
 *		antispam=accept any
 *
 *	firewallScheme scheme=Email ruleset="antispam" varvalue="(var)header";
 *		If header is (array)from=>'abc@xyz.net',subject='cheap viagra on sale',
 *		result%firewallScheme will be "discard".
 ************************************************************/

function firewallScheme
{
	result%function = "";
	verbose = "{arg%verbose}";

	schm = "{arg%scheme}";
	if ({#schm:} == 0) return;

	rs = "{arg%ruleset}";
	if ({#rs:} == 0) {
		rs = "{arg%default}";
		if ('{verbose}') display "No ruleset is specified.  Use default [{rs}].<br>\n";
	}

	rsArr = (var)scheme%{schm}&{rs};
	if ({#rsArr} == 0 && '{rs}' != '{arg%default}') {
		if ('{verbose}') display "Ruleset specified but not found in scheme.  Use default [{arg%default}].<br>\n";
		rsArr = (var)scheme%{schm}&{arg%default};
	}

//display "rsArr=[{rsArr|list}]<br>\n";
//display "varvalue=[{arg%varvalue|list}]<br>\n";
//display "firewallRuleset ruleset=(var)rsArr varname=\"{arg%varname}\" varvalue=\"(var)arg%varvalue\" verbose=\"{verbose}\";<br>\n";
	firewallRuleset ruleset=(var)rsArr varname="{arg%varname}" varvalue="(var)arg%varvalue" verbose="{verbose}";
	result%function = (var)result%firewallRuleset;
}
</script>
