//**********
// Field Check Version 1.0

function trim(str)
{
	ret = str;
	ret = ret.replace(/^\s*/, '');
	ret = ret.replace(/\s*$/, '');
	return ret;
}

function properCase(str)
{
	ret = str;
	i = 0;
	while ((found = ret.match(/^(.*\b)([a-z])(.*)$/)) == true)
	{
		ret = found[1] + found[2].toUpperCase() + found[3];
		if (i++ > 100) break;
	}
	return ret;
}

function useNewValue(fld, newVal, errMsg)
{
	ret = true;
	em = (errMsg) ? errMsg : '"' + fld.value + '" is not valid.';
	if (fld.value != newVal)
	{
		//ret = confirm(em + '\n\n' +
		//	'If you want to use "' + newVal + '" instead, please click OK.\n' +
		//	'Otherwise, please click Cancel to re-enter.');
		//if (ret) fld.value = newVal;
		alert(em);
		ret = false;
	}
	return ret;
}


var fldchk_underNBChecked = '';

function nonBlankCheck(fld, em)
{
	ret = true;
	// To avoid endless loop when getting focus
	// from another nonBlank field
	if (fldchk_underNBChecked != '' && fldchk_underNBChecked != fld.name) return ret;

	fldchk_underNBChecked = '';
	if (fld.value == '')
	{
		fldchk_underNBChecked = fld.name;
		alert((em) ? em : 'Please enter a value.');
		fld.focus();
		ret = false;
	}
	return ret;
}

function codeCheck(fld, maxLen)
{
	val = fld.value;
	val = val.replace(/\s/g, '');
	val = val.toUpperCase();
	if (maxLen != null) val = val.substring(0, maxLen)
	fld.value = val;
	return true;
}

function numberCheck(fld, minVal, maxVal)
{
	em = '';
	val = fld.value;
	val = val.replace(/[^0-9.]/g, '');

	if ((minVal != null && maxVal != null) && val != '' && (val > maxVal || val < minVal))
	{
		em = 'Value must be between ' + minVal + ' and ' + maxVal + ' inclusively.';
		if (val < minVal) val = minVal;
		if (val > maxVal) val = maxVal;
	}

	if (minVal != null)
	{
		if (val == '') val = minVal;
		if (val < minVal)
		{
			em = 'Value is at least ' + minVal + '.';
			val = minVal;
		}
	}
	
	if (maxVal != null)
	{
		if (val == '') val = maxVal;
		if (val > maxVal)
		{
			em = 'Value is at most ' + maxVal + '.';
			val = maxVal;
		}
	}

	return useNewValue(fld, val, em);
}

function dateCheck(fld)
{
	if (fld.value != '' && !fld.value.match(/\d\d?\/\d\d?\/\d\d\d\d/))
	{
		alert('Please enter in dd/mm/yy format.');
		return false;
	}
	return true;
}

function properCheck(fld)
{
	val = fld.value;
	val = properCase(val);
	fld.value = val;
	return true;
}
