<?php include("bee/compiler.php"); return; ?>
<script language="bee">
/************************************************************
 *	SOAP
 ************************************************************/


/************************************************************
 *	soapsend: Send a SOAP request to the remote server
 *
 *	arg%soap_location - the location of the service
 *	arg%soap_operation - the operation
 *
 *	arg%soap_argv - the argument array (if absent, use all other
 *		arg% variables that do not start with "soap_")
 *
 *	The following arguments are used only to overwrite the above:
 *
 *	arg%soap_server - if present, overwrite the server name in arg%soap_location
 *	arg%soap_pathpage - if present, overwrite the full path in arg%soap_location
 *	arg%soap_namespace - if present, overwrite the target namespace derived from arg%soap_location
 ************************************************************/

function soapsend
{
	// Process arguments

	var locationPart = "{arg%soap_location}" conv="parseurl";
	var operation = "{arg%soap_operation}";
	var arguments = "(var)arg%soap_argv";
	if ({#arguments} == 0) {
		// No arguments.  Scan for non "soap_" arguments.
		var argFunc = "(var)arg%function" conv="nosysargs";
		foreach (argFunc) {
			if ({foreach:key|foundre:^soap_} == 0)
				var arguments:{foreach:key} = "{foreach}";
		}
	}

	if ({arg%soap_server|isset}) var server = "{arg%soap_server}";
	else var server = "{locationPart:host}";

	if ({arg%soap_pathpage|isset}) var pathpage = "{arg%soap_pathpage}";
	else var pathpage = "{locationPart:path}";

	if ({arg%soap_namespace|isset}) var namespace = "{arg%soap_namespace}";
	else var namespace = "{locationPart:scheme}://{locationPart:host}{locationPart:path}";

	var tcpport = "{locationPart:port|if:{#locationPart:port},80}";
	var httpversion = "1.1";


	// SOAP constant
	//var soapNS = "http://www.w3.org/2001/12/soap-envelope";
	//var soapEnc = "http://www.w3.org/2001/12/soap-encoding";
	var SOAP_envelope = "http://schemas.xmlsoap.org/soap/envelope/";
	var SOAP_encoding = "http://schemas.xmlsoap.org/soap/encoding/";
	var nsXSI = "http://www.w3.org/1999/XMLSchema-instance";
	var nsXSD = "http://www.w3.org/1999/XMLSchema";

	// XML now	

	var request = '<?xml version="1.0"?>
<SOAP-ENV:Envelope
xmlns:SOAP-ENV="{SOAP_envelope}"
xmlns:xsi="{nsXSI}"
xmlns:xsd="{nsXSD}"
SOAP-ENV:encodingStyle="{SOAP_encoding}">
\t<SOAP-ENV:Body>
\t\t<tns:{operation} xmlns:tns="{namespace}">';

	foreach (arguments as elem) {
		var elem:type = "string";
		var reg = "{elem}" conv="match:^\[(.*)\](.*)$";
		if ({#reg}) {
			var elem:type = "{reg:#1}";
			var elem = "{reg:#2}";
		}
		var request = '{request}
\t\t\t<{elem:key} xsi:type="xsd:{elem:type}">{elem}</{elem:key}>';
	}

	var request = '{request}
\t\t</tns:{operation}>
\t</SOAP-ENV:Body>
</SOAP-ENV:Envelope>';

	var soapRequest = 'POST {pathpage} HTTP/{httpversion}
Host: {server}
Content-Type: text/xml; charset="utf-8"
Content-Length: {#request:}
SOAPAction: {operation}

{request}
';

	socketcreate socket="soapSock";
	if ('{status%socket}') return status="{status%socket}" message="{message%socket}";

	socketconnect socket="soapSock" address="{server}" port="{tcpport}";
	if ('{status%socket}') return status="{status%socket}" message="{message%socket}";

	socketwrite socket="soapSock" content="{soapRequest}";
	if ('{status%socket}') return status="{status%socket}" message="{message%socket}";

	var soapResponse = "";
	socketread socket="soapSock";
	while ({soapSock%read:length}) {
			var soapResponse = "{soapResponse}{soapSock%read:content}";
			socketread socket="soapSock";
	}

	//var response = "{soapResponse|replacere:^([^\n\r]+\r?\n)+\r?\n\r?\n}";
	var response = "{soapResponse}";
	var response = "{response|replacere:^[^<]*}";
	var response = "{response|replacere:[^>]*$}";

	var result%function = "{response}";
	var result%function:request = "{request}";
	var result%function:response = "{response}";
	var result%function:soaprequest = "{soapRequest}";
	var result%function:soapresponse = "{soapResponse}";
}
</script>
